library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity mux is
	port(
	in_00 	:in integer;
	in_01 	:in integer;
	in_02 	:in integer;
	in_03 	:in integer;
	in_10 	:in integer;
	in_11 	:in integer;
	in_12 	:in integer;
	in_13 	:in integer;
	in_20 	:in integer;
	in_21 	:in integer;
	in_22 	:in integer;
	in_23 	:in integer;
	in_30 	:in integer;
	in_31 	:in integer;
	in_32 	:in integer;
	in_33	:in integer;
	sel		:in std_logic_vector(3 downto 0);
	x_out	:out std_logic_vector(31 downto 0)
	);									   
end entity mux;

architecture behavioral of mux is

begin
	muxing: process(sel,in_00,in_01,in_02,in_03,in_10,in_11,in_12,in_13,in_20,in_21,in_22,in_23,in_30,in_31,in_32) is
	begin
		case sel is 
			when "0000" => x_out <= std_logic_vector(to_signed(in_00, 32));
			when "0001" => x_out <= std_logic_vector(to_signed(in_01, 32));
			when "0010" => x_out <= std_logic_vector(to_signed(in_02, 32));
			when "0011" => x_out <= std_logic_vector(to_signed(in_03, 32));
			when "0100" => x_out <= std_logic_vector(to_signed(in_10, 32));
			when "0101" => x_out <= std_logic_vector(to_signed(in_11, 32));
			when "0110" => x_out <= std_logic_vector(to_signed(in_12, 32));
			when "0111" => x_out <= std_logic_vector(to_signed(in_13, 32));
			when "1000" => x_out <= std_logic_vector(to_signed(in_20, 32));
			when "1001" => x_out <= std_logic_vector(to_signed(in_21, 32));
			when "1010" => x_out <= std_logic_vector(to_signed(in_22, 32));
			when "1011" => x_out <= std_logic_vector(to_signed(in_23, 32));
			when "1100" => x_out <= std_logic_vector(to_signed(in_30, 32));
			when "1101" => x_out <= std_logic_vector(to_signed(in_31, 32));
			when "1110" => x_out <= std_logic_vector(to_signed(in_32, 32));
			when "1111" => x_out <= std_logic_vector(to_signed(in_33, 32));
			when others => x_out <= std_logic_vector(to_signed(in_00, 32));
		end case;
	end process;
end architecture;

			
	