library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity mux_tstamp is
	port(
	in_00 	:in std_logic_vector(31 downto 0);
	in_01 	:in std_logic_vector(31 downto 0);
	in_02 	:in std_logic_vector(31 downto 0);
	in_03 	:in std_logic_vector(31 downto 0);
	in_10 	:in std_logic_vector(31 downto 0);
	in_11 	:in std_logic_vector(31 downto 0);
	in_12 	:in std_logic_vector(31 downto 0);
	in_13 	:in std_logic_vector(31 downto 0);
	in_20 	:in std_logic_vector(31 downto 0);
	in_21 	:in std_logic_vector(31 downto 0);
	in_22 	:in std_logic_vector(31 downto 0);
	in_23 	:in std_logic_vector(31 downto 0);
	in_30 	:in std_logic_vector(31 downto 0);
	in_31 	:in std_logic_vector(31 downto 0);
	in_32 	:in std_logic_vector(31 downto 0);
	sel		:in std_logic_vector(3 downto 0);
	x_out	:out std_logic_vector(31 downto 0)
	);									   
end entity mux_tstamp;

architecture behavioral of mux_tstamp is

begin
	muxing: process(sel,in_00,in_01,in_02,in_03,in_10,in_11,in_12,in_13,in_20,in_21,in_22,in_23,in_30,in_31,in_32) is
	begin
		case sel is 
			when "0000" => x_out <= in_00;
			when "0001" => x_out <= in_01;
			when "0010" => x_out <= in_02;
			when "0011" => x_out <= in_03;
			when "0100" => x_out <= in_10;
			when "0101" => x_out <= in_11;
			when "0110" => x_out <= in_12;
			when "0111" => x_out <= in_13;
			when "1000" => x_out <= in_20;
			when "1001" => x_out <= in_21;
			when "1010" => x_out <= in_22;
			when "1011" => x_out <= in_23;
			when "1100" => x_out <= in_30;
			when "1101" => x_out <= in_31;
			when "1110" => x_out <= in_32;
			when others => x_out <= in_00;
		end case;
	end process;
end architecture;

			
	