----------------------------------------------------------------------------------
-- 64 Bit Buffer.vhd
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity buffer_64bit is
    Port ( x_in        :        in     STD_LOGIC_VECTOR(7 downto 0);
           instruction :        in     STD_LOGIC_VECTOR(1 downto 0); -- Intruksjon fra Control
           clk         :        in     STD_LOGIC;
           reset       :        in     STD_LOGIC;
           x_out       :        out    STD_LOGIC_VECTOR(7 downto 0); -- Utangen fra bufferet
           adresse     :        out    STD_LOGIC_VECTOR(3 downto 0)); -- Pakken som ligger lagret sin destinasjonsadresse
end buffer_64bit;

architecture Behavioral of buffer_64bit is

signal regA,regB,regC,regD,regE,regF,regG,regH : STD_LOGIC_VECTOR(7 downto 0);

begin
-----------------------
---- Utgangen settes --    
x_out <= regA;
adresse <= regA(7 downto 4);
    
    
--------------------------
-- 64 bit shiftregister --    
process(clk,reset) is
    
begin
       
    ---- Reset ----
    if reset  = '0' then
           regA <= x"00";regB <= x"00";regC <= x"00";regD <= x"00";
           regE <= x"00";regF <= x"00";regG <= x"00";regH <= x"00";
		
	 elsif clk'event and clk = '1' then
	       case instruction is
            	 ----	Read In ----
	           when "00" =>
	                 regA <= regB ; regB <= regC ; regC <= regD ; regD <= regE; 
	                 regE <= regF ; regF <= regG ; regG <= regH ; regH <= x_in;
            	       
 	           ---- Read Out ----
 	           when "01" =>
 	                
 	                 regA <= regB ; regB <= regC ; regC <= regD ; regD <= regE; 
	                 regE <= regF ; regF <= regG ; regG <= regH ; regH <= regA;
            	      
 	           ---- IDLE ----
 	           when others => null;
 	       end case;     
	 end if;
end process;
end Behavioral;

