----------------------------------
--Linear Feedback Shift Register--
--Periode: 255 clock cycles     --
--Max Clk_freq: 372 Mhz			--
--Written by: Andreas Heps     --
----------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity LFSR_8 is
	port(
	clk		: in std_logic;
	reset	: in std_logic;
	enable	: in std_logic;
	c_out	: out std_logic_vector(7 downto 0)
	);
end entity;

architecture behavioral of LFSR_8 is

signal count	: std_logic_vector(7 downto 0);
signal LF		: std_logic;

begin
	
	LF <= not(count(7) xor count(5) xor count(4) xor count(3));
	
	process(clk, reset) is
	begin
		if reset = '0' then
			count <= (others => '0');
		elsif rising_edge(clk) then
			if enable = '1' then
				count <= (count(6) & count(5) & count(4) 
				& count(3) & count(2) & count(1)
				& count(0) & LF);
			end if;
		end if;
	end process;
	c_out <= count;
end architecture;