-------------------------------------------------------------
--With a clock of 50Mhz this counter will manage 		   --
--85 seconds before reaching the limit of the integer value--
-------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity global_counter is
	port(
	clk			: in std_logic;
	reset		: in std_logic;
	start_testing	: in std_logic;
	global_time	: out std_logic_vector(31 downto 0)
	);
end entity;

architecture behavioral of global_counter is

begin
	count: process(clk,reset) is
	variable internal_counter : integer;
	
	begin
		if reset = '0' or start_testing = '0' then
			global_time <= (others=> '0');
			internal_counter := 0;
		
		elsif clk'event and clk = '1' then
			internal_counter := internal_counter + 1;
			global_time <= std_logic_vector(to_unsigned(internal_counter,32));
		
		end if;
	end process;
end architecture;

